/** @file fontimage_opts.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef FONTIMAGE_OPTS_H
#define FONTIMAGE_OPTS_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "fontimage"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "fontimage"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int width_arg;	/**< @brief Specifies the number of pixels wide to make the output image. If this is omitted (or specified as -1) then the image will be made as wide as it needs to be..  */
  char * width_orig;	/**< @brief Specifies the number of pixels wide to make the output image. If this is omitted (or specified as -1) then the image will be made as wide as it needs to be. original value given at command line.  */
  const char *width_help; /**< @brief Specifies the number of pixels wide to make the output image. If this is omitted (or specified as -1) then the image will be made as wide as it needs to be. help description.  */
  int height_arg;	/**< @brief Specifies the number of pixels high to make the output image. If this is omitted (or specified as -1) then the image will be made as high as it needs to be..  */
  char * height_orig;	/**< @brief Specifies the number of pixels high to make the output image. If this is omitted (or specified as -1) then the image will be made as high as it needs to be. original value given at command line.  */
  const char *height_help; /**< @brief Specifies the number of pixels high to make the output image. If this is omitted (or specified as -1) then the image will be made as high as it needs to be. help description.  */
  int pixelsize_arg;	/**< @brief Specifies the size at which the next piece(s) of text will be printed. This may also be specified multiple times..  */
  char * pixelsize_orig;	/**< @brief Specifies the size at which the next piece(s) of text will be printed. This may also be specified multiple times. original value given at command line.  */
  const char *pixelsize_help; /**< @brief Specifies the size at which the next piece(s) of text will be printed. This may also be specified multiple times. help description.  */
  char ** text_arg;	/**< @brief Specifies a line or comma-separated lines of text to be printed on the image. To include a comma in the text, write `\\,'. If STRING is `<fontname>', the fontname will be used instead. May be specified multiple times..  */
  char ** text_orig;	/**< @brief Specifies a line or comma-separated lines of text to be printed on the image. To include a comma in the text, write `\\,'. If STRING is `<fontname>', the fontname will be used instead. May be specified multiple times. original value given at command line.  */
  unsigned int text_min; /**< @brief Specifies a line or comma-separated lines of text to be printed on the image. To include a comma in the text, write `\\,'. If STRING is `<fontname>', the fontname will be used instead. May be specified multiple times.'s minimum occurreces */
  unsigned int text_max; /**< @brief Specifies a line or comma-separated lines of text to be printed on the image. To include a comma in the text, write `\\,'. If STRING is `<fontname>', the fontname will be used instead. May be specified multiple times.'s maximum occurreces */
  const char *text_help; /**< @brief Specifies a line or comma-separated lines of text to be printed on the image. To include a comma in the text, write `\\,'. If STRING is `<fontname>', the fontname will be used instead. May be specified multiple times. help description.  */
  char * output_arg;	/**< @brief Specifies the name of the output image file. It must have an extension of either `.png' or `.bmp'. If this option is omitted, fontimage will chose a filename based on the font name..  */
  char * output_orig;	/**< @brief Specifies the name of the output image file. It must have an extension of either `.png' or `.bmp'. If this option is omitted, fontimage will chose a filename based on the font name. original value given at command line.  */
  const char *output_help; /**< @brief Specifies the name of the output image file. It must have an extension of either `.png' or `.bmp'. If this option is omitted, fontimage will chose a filename based on the font name. help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int width_given ;	/**< @brief Whether width was given.  */
  unsigned int height_given ;	/**< @brief Whether height was given.  */
  unsigned int pixelsize_given ;	/**< @brief Whether pixelsize was given.  */
  unsigned int text_given ;	/**< @brief Whether text was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* FONTIMAGE_OPTS_H */
